commit ac4677491b2ef479d96202e2db8aabfe1441343a
Author: Gao,Yan <ygao@suse.com>
Date:   Mon Apr 14 20:46:13 2014 +0800

    Test: pengine: Ignore failure-timeout only if the failed operation has on-fail="block" (update a regression test)

diff --git a/pengine/test10/failcount-block.exp b/pengine/test10/failcount-block.exp
index d54c27d..68fb6ee 100644
--- a/pengine/test10/failcount-block.exp
+++ b/pengine/test10/failcount-block.exp
@@ -19,20 +19,20 @@
   </synapse>
   <synapse id="2">
     <action_set>
-      <rsc_op id="14" operation="monitor" operation_key="rsc_pcmk-3_monitor_5000" on_node="pcmk-1" on_node_uuid="101">
+      <rsc_op id="15" operation="monitor" operation_key="rsc_pcmk-3_monitor_5000" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-3" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.107"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="13" operation="start" operation_key="rsc_pcmk-3_start_0" on_node="pcmk-1" on_node_uuid="101"/>
+        <rsc_op id="14" operation="start" operation_key="rsc_pcmk-3_start_0" on_node="pcmk-1" on_node_uuid="101"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="3">
     <action_set>
-      <rsc_op id="13" operation="start" operation_key="rsc_pcmk-3_start_0" on_node="pcmk-1" on_node_uuid="101">
+      <rsc_op id="14" operation="start" operation_key="rsc_pcmk-3_start_0" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-3" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.107"/>
       </rsc_op>
@@ -41,7 +41,7 @@
   </synapse>
   <synapse id="4">
     <action_set>
-      <crm_event id="4" operation="clear_failcount" operation_key="rsc_pcmk-3_clear_failcount" on_node="pcmk-1" on_node_uuid="101">
+      <crm_event id="5" operation="clear_failcount" operation_key="rsc_pcmk-3_clear_failcount" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-3" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_op_no_wait="true" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.107"/>
       </crm_event>
@@ -50,20 +50,20 @@
   </synapse>
   <synapse id="5">
     <action_set>
-      <rsc_op id="16" operation="monitor" operation_key="rsc_pcmk-4_monitor_5000" on_node="pcmk-1" on_node_uuid="101">
+      <rsc_op id="17" operation="monitor" operation_key="rsc_pcmk-4_monitor_5000" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-4" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_fail="block" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.108"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="15" operation="start" operation_key="rsc_pcmk-4_start_0" on_node="pcmk-1" on_node_uuid="101"/>
+        <rsc_op id="16" operation="start" operation_key="rsc_pcmk-4_start_0" on_node="pcmk-1" on_node_uuid="101"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="6">
     <action_set>
-      <rsc_op id="15" operation="start" operation_key="rsc_pcmk-4_start_0" on_node="pcmk-1" on_node_uuid="101">
+      <rsc_op id="16" operation="start" operation_key="rsc_pcmk-4_start_0" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-4" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.108"/>
       </rsc_op>
@@ -72,7 +72,7 @@
   </synapse>
   <synapse id="7">
     <action_set>
-      <crm_event id="5" operation="clear_failcount" operation_key="rsc_pcmk-5_clear_failcount" on_node="pcmk-1" on_node_uuid="101">
+      <crm_event id="6" operation="clear_failcount" operation_key="rsc_pcmk-5_clear_failcount" on_node="pcmk-1" on_node_uuid="101">
         <primitive id="rsc_pcmk-5" class="ocf" provider="heartbeat" type="IPaddr2"/>
         <attributes CRM_meta_op_no_wait="true" CRM_meta_timeout="90000" cidr_netmask="32"  ip="192.168.122.108"/>
       </crm_event>